## mingw-w64-qt6-mqtt-6.10.0-1.src.tar.zst

=== CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

include(.cmake.conf)
project(QtMqtt
    VERSION "${QT_REPO_MODULE_VERSION}"
    DESCRIPTION "Qt Mqtt Libraries"
    HOMEPAGE_URL "https://qt.io/"
    LANGUAGES CXX C
)

find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED COMPONENTS BuildInternals Core Network)
find_package(Qt6 ${PROJECT_VERSION} CONFIG OPTIONAL_COMPONENTS Quick  # For tests
                                                               Gui Widgets WebSockets) # For examples
qt_internal_project_setup()

qt_build_repo()

=== tests/CMakeLists.txt ===
# Copyright (C) 2025 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# This function adds the test 12 times if run on a computer where the
# mosquitto broker has been provisioned by running the corresponding
# script located qt6/coin/provisioning/*/*mosquitto*
#
# The script adds the file /etc/mosquitto/conf.d/mqtt.conf on unix-like
# systems, and the file C:\\Program Files\\mosquitto\\conf.d\\mqtt.conf
# on windows like systems. So this is what we test for.
#
# If we are on a provisioned system as detected by the two files above
# we define these variables which the test use
#   MQTT_TEST_TYPE= selection from; 3, 4, 5
#     3 -> Vers 3.1
#     4 -> Vers 3.1.1
#     5 -> Vers 5.0
#   MQTT_TEST_PROTOCOL= selection from; Tcp,Ssl,Ws,Wss
#   MQTT_TEST_BROKER="localhost"
#
# If neither of these files are present, we use the existing
# design which is to run for tcp,3.1.1 by default.
# In this case set the environment variable MQTT_TEST_BROKER
# to localhost
#
# Finally, we allow the test to override for individual test
# cases, if wanted. This is mostly used for MQTT_TEST_TYPE
#

function(qtmqtt_is_mosquitto_installed result)
    set(skip $ENV{COIN_NO_MOSQUITTO})
    if(skip)
       set(${result} FALSE PARENT_SCOPE)
     elseif(EXISTS "/etc/mosquitto/conf.d/mqtt.conf" OR
       EXISTS "C:\\Program Files\\mosquitto\\conf.d\\mqtt.conf")
       set(${result} ON PARENT_SCOPE)
    else()
       set(${result} FALSE PARENT_SCOPE)
    endif()
endfunction()

function(qtmqtt_add_test)

    set(options)
    set(oneValueArgs TARGET)
    set(multiValueArgs SOURCES DEFINES INCLUDE_DIRECTORIES LIBRARIES)

    cmake_parse_arguments(
        arg_mqtt
        "${options}"
        "${oneValueArgs}"
        "${multiValueArgs}"
        ${ARGN}
    )

    set(TYPES)
    set(PROTOCOLS)

    qtmqtt_is_mosquitto_installed(is_installed)

    if(${is_installed})
        if(WASM)
            if(TARGET Qt::WebSockets)
                set(TYPES Ws Wss)
                set(PROTOCOLS 3 4 5)
            endif()
        elseif(QT_FEATURE_ssl)
            if(TARGET Qt::WebSockets)
                set(TYPES Tcp Ssl Ws Wss)
            else()
                set(TYPES Tcp Ssl)
            endif()
            set(PROTOCOLS 3 4 5)
        else()
            if(TARGET Qt::WebSockets)
                set(TYPES Tcp Ws)
            else()
                set(TYPES Tcp)
            endif()
            set(PROTOCOLS 3 4 5)
        endif()
    elseif(NOT WASM)
        set(TYPES Tcp)
        set(PROTOCOLS 4)
    endif()

    foreach(TYPE ${TYPES})
        foreach(PROTOCOL ${PROTOCOLS})
            set(EXTRA_DEFINES)
            set(EXTRA_LIBS)
            if(${is_installed})
                set(EXTRA_DEFINES MQTT_TEST_TYPE="${TYPE}" MQTT_TEST_PROTOCOL=${PROTOCOL} MQTT_TEST_BROKER="localhost")
            endif()

            if(TARGET Qt::WebSockets)
                set(EXTRA_DEFINES ${EXTRA_DEFINES} QT_MQTT_WITH_WEBSOCKETS)
                set(EXTRA_LIBS Qt::WebSockets)
            endif()

            qt_internal_add_test(
                    ${arg_mqtt_TARGET}_${TYPE}_${PROTOCOL}
                SOURCES
                    ${arg_mqtt_SOURCES}
                DEFINES
                    ${arg_mqtt_DEFINES} ${EXTRA_DEFINES}
                INCLUDE_DIRECTORIES
                    ${arg_mqtt_INCLUDE_DIRECTORIES}
                LIBRARIES
                    ${arg_mqtt_LIBRARIES} ${EXTRA_LIBS}
                TESTDATA
                    "../../certificate/cert.crt"
                    "../../certificate/cert.key"
                BUILTIN_TESTDATA
            )

        endforeach()
    endforeach()
endfunction()

if(QT_BUILD_STANDALONE_TESTS)
    # Add qt_find_package calls for extra dependencies that need to be found when building
    # the standalone tests here.
endif()
qt_build_tests()

=== src/mqtt/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## Mqtt Module:
#####################################################################

qt_internal_add_module(Mqtt
    SOURCES
        qmqttauthenticationproperties.cpp qmqttauthenticationproperties.h
        qmqttclient.cpp qmqttclient.h qmqttclient_p.h
        qmqttconnection.cpp qmqttconnection_p.h
        qmqttconnectionproperties.cpp qmqttconnectionproperties.h qmqttconnectionproperties_p.h
        qmqttcontrolpacket.cpp qmqttcontrolpacket_p.h
        qmqttglobal.h qmqttglobal_p.h
        qmqttmessage.cpp qmqttmessage.h qmqttmessage_p.h
        qmqttpublishproperties.cpp qmqttpublishproperties.h qmqttpublishproperties_p.h
        qmqttsubscription.cpp qmqttsubscription.h qmqttsubscription_p.h
        qmqttsubscriptionproperties.cpp qmqttsubscriptionproperties.h
        qmqtttopicfilter.cpp qmqtttopicfilter.h
        qmqtttopicname.cpp qmqtttopicname.h
        qmqtttype.cpp qmqtttype.h
    LIBRARIES
        Qt::CorePrivate
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::Network
    PRIVATE_MODULE_INTERFACE
        Qt::CorePrivate
)

qt_internal_extend_target(Mqtt
    CONDITION
        TARGET Qt::WebSockets
    DEFINES
        QT_MQTT_WITH_WEBSOCKETS
    PUBLIC_LIBRARIES
        Qt::WebSockets
    SOURCES
        transportLayers/mqtt_websocket_io_base.cpp
        transportLayers/mqtt_websocket_io_base_p.h
        transportLayers/mqtt_websocket_io.cpp
        transportLayers/mqtt_websocket_io_p.h
        transportLayers/mqtt_secure_websocket_io.cpp
        transportLayers/mqtt_secure_websocket_io_p.h
)

qt_internal_add_docs(Mqtt
    doc/qtmqtt.qdocconf
)

=== tests/auto/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(WIN32 OR (LINUX AND NOT CMAKE_CROSSCOMPILING))
    add_subdirectory(cmake)
    add_subdirectory(conformance)
    add_subdirectory(qmqttconnectionproperties)
    add_subdirectory(qmqttcontrolpacket)
    add_subdirectory(qmqttclient)
    add_subdirectory(qmqttlastwillproperties)
    add_subdirectory(qmqttpublishproperties)
    add_subdirectory(qmqttsubscription)
    add_subdirectory(qmqttsubscriptionproperties)
    add_subdirectory(qmqtttopicname)
    add_subdirectory(qmqtttopicfilter)
endif()

=== tests/auto/conformance/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_conformance Test:
#####################################################################

qtmqtt_add_test(
    TARGET
        tst_conformance
    SOURCES
        ../../common/broker_connection.h
        tst_conformance.cpp
    DEFINES
        SRCDIR="${CMAKE_CURRENT_SOURCE_DIR}/"
    INCLUDE_DIRECTORIES
        ../../common
    LIBRARIES
        Qt::MqttPrivate
        Qt::Mqtt
        Qt::Network
)

=== tests/auto/qmqttclient/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qmqttclient Test:
#####################################################################

qtmqtt_add_test(
    TARGET
        tst_qmqttclient
    SOURCES
        ../../common/broker_connection.h
        tst_qmqttclient.cpp
    DEFINES
        SRCDIR="${CMAKE_CURRENT_SOURCE_DIR}/"
    INCLUDE_DIRECTORIES
        ../../common
    LIBRARIES
        Qt::MqttPrivate
        Qt::Mqtt
        Qt::Network
)

=== tests/auto/qmqttconnectionproperties/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qmqttconnectionproperties Test:
#####################################################################

qtmqtt_add_test(
    TARGET
        tst_qmqttconnectionproperties
    SOURCES
        ../../common/broker_connection.h
        tst_qmqttconnectionproperties.cpp
    DEFINES
        SRCDIR="${CMAKE_CURRENT_SOURCE_DIR}/"
    INCLUDE_DIRECTORIES
        ../../common
    LIBRARIES
        Qt::MqttPrivate
        Qt::Mqtt
        Qt::Network
)

=== tests/auto/qmqttcontrolpacket/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qmqttcontrolpacket Test:
#####################################################################

qtmqtt_add_test(
    TARGET
        tst_qmqttcontrolpacket
    SOURCES
        tst_qmqttcontrolpacket.cpp
    DEFINES
        SRCDIR="${CMAKE_CURRENT_SOURCE_DIR}/"
    LIBRARIES
        Qt::MqttPrivate
        Qt::Mqtt
        Qt::Network
)

=== tests/auto/qmqttlastwillproperties/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qmqttlastwillproperties Test:
#####################################################################

qtmqtt_add_test(
    TARGET
        tst_qmqttlastwillproperties
    SOURCES
        ../../common/broker_connection.h
        tst_qmqttlastwillproperties.cpp
    DEFINES
        SRCDIR="${CMAKE_CURRENT_SOURCE_DIR}/"
    INCLUDE_DIRECTORIES
        ../../common
    LIBRARIES
        Qt::MqttPrivate
        Qt::Mqtt
        Qt::Network
)

=== tests/auto/qmqttpublishproperties/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qmqttpublishproperties Test:
#####################################################################

qtmqtt_add_test(
    TARGET
        tst_qmqttpublishproperties
    SOURCES
        ../../common/broker_connection.h
        tst_qmqttpublishproperties.cpp
    DEFINES
        SRCDIR="${CMAKE_CURRENT_SOURCE_DIR}/"
    INCLUDE_DIRECTORIES
        ../../common
    LIBRARIES
        Qt::MqttPrivate
        Qt::Mqtt
        Qt::Network
)

=== tests/auto/qmqttsubscription/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qmqttsubscription Test:
#####################################################################

qtmqtt_add_test(
    TARGET
        tst_qmqttsubscription
    SOURCES
        ../../common/broker_connection.h
        tst_qmqttsubscription.cpp
    DEFINES
        SRCDIR="${CMAKE_CURRENT_SOURCE_DIR}/"
    INCLUDE_DIRECTORIES
        ../../common
    LIBRARIES
        Qt::MqttPrivate
        Qt::Mqtt
        Qt::Network
)

=== tests/auto/qmqttsubscriptionproperties/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qmqttsubscriptionproperties Test:
#####################################################################

qtmqtt_add_test(
    TARGET
        tst_qmqttsubscriptionproperties
    SOURCES
        ../../common/broker_connection.h
        tst_qmqttsubscriptionproperties.cpp
    DEFINES
        SRCDIR="${CMAKE_CURRENT_SOURCE_DIR}/"
    INCLUDE_DIRECTORIES
        ../../common
    LIBRARIES
        Qt::MqttPrivate
        Qt::Mqtt
        Qt::Network
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-mqtt
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
pkgver=6.10.0
pkgrel=1
pkgdesc='Qt Module to implement MQTT protocol version 3.1 and 3.1.1 (mingw-w64)'
arch=(any)
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtmqtt.git"
msys2_references=(
  'archlinux: qt6-mqtt'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:GPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "rsync")
_pkgfn="${_realname/6-/}-${pkgver}"
source=("https://github.com/qt/qtmqtt/archive/v${pkgver}/${_pkgfn}.tar.gz")
sha256sums=('da442c5e3fab6314f70ca6a6c2b9491018b15ef125e4c621bb3a825868841a6a')

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-mqtt() {
  depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
           "${MINGW_PACKAGE_PREFIX}-qt6-base")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs "${pkgdir}"/.${MINGW_PREFIX} "${srcdir}"/${MSYSTEM}-debug/

  install -d "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 ${_pkgfn}/LICENSES/* -t "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-mqtt-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf "${srcdir}"/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
